Name:		Topologic
Version:	0.0
Release:	0.20221210git%{?dist}
Summary:	Logical, hierarchical and topological representation of spaces and entities
License:	AGPLv3
URL:		https://github.com/wassimj/Topologic/
Source0:	Topologic.zip
Patch0:         Topologic-linux-build.patch
BuildRequires:	cmake gcc-c++ opencascade-devel libuuid-devel dos2unix
BuildRequires:  python3-devel
BuildRequires:  pybind11-devel

%description
Topologic is a software modeling library enabling hierarchical and topological
representations of architectural spaces, buildings and artifacts through
non-manifold topology.

%package devel
Summary:	Development headers for linking to the TopologicCore library
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	opencascade-devel libuuid-devel

%package python3
Summary:	A python module for the TopologicCore BIM library
Requires:	%{name} = %{version}-%{release}
Provides:       python3-topologicPy > 0.5-0.0.20210615git python3-topologic > 0.5-0.0.20211018git

%description devel
The Topologic-devel package includes the header files necessary for
developing programs which will use the TopologicCore library.

%description python3
A python module for the TopologicCore BIM library

%prep
#setup -q -n Topologic
%autosetup -p1 -n Topologic
dos2unix README.md

%build
%cmake -DLIBDIR=%{_libdir} -DINCLUDEDIR=%{_includedir} -DENABLE_BUILD_OPTIMIZATIONS=ON -DOCC_INCLUDE_DIR=%{_includedir}/opencascade
%cmake_build
cp -a *-linux-*/TopologicCore/libTopologicCore.so* ./

cd Python-Bindings
# defining CMAKE_CXX_FLAGS overrides all the fedora default flags, restore them
%cmake -DCMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES=/usr/include -DCMAKE_CXX_FLAGS="-L../../ %build_cxxflags"
%cmake_build

%install
%cmake_install

mkdir -p $RPM_BUILD_ROOT/%{python3_sitearch}
cp Python-Bindings/*/topologic.cpython*.so $RPM_BUILD_ROOT/%{python3_sitearch}/

%files
%doc README.md
%{_libdir}/libTopologicCore.so.*

%files python3
%{python3_sitearch}/*

%files devel
%doc README.md
%{_includedir}/TopologicCore
%{_libdir}/libTopologicCore.so

%changelog
* Sat Dec 10 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20221210git
- git snapshot
- revert to system pybind11 as f37 ships with 2.10.1

* Sun Nov 13 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20221113git
- git snapshot
- use bundled pybind11 as f36/pybind11-2.9.2 is ok but f37/pybind11-2.10.0 is not

* Mon Jan 31 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220131git
- git snapshot (NoGlobalCluster branch is merged)

* Wed Jan 19 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220119git
- git snapshot of NoGlobalCluster branch

* Mon Jan 17 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220117git
- git snapshot + 2nd patch to remove GlobalCluster + patch for CellComplex.ByFaces()

* Sat Jan 08 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220108git
- git snapshot + patch to remove GlobalCluster + patch for CellComplex.ByFaces()

* Thu Jan 06 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220106git
- git snapshot + patch to remove GlobalCluster

* Tue Jan 04 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220104git
- git snapshot + linux cmake patch

* Sun Jan 02 2022 Bruno Postle <bruno@postle.net> - 0.0-0.20220102git
- git snapshot + range-loop-construct warning fixes

* Thu Oct 28 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20211028git
- upstream, build c++ and python

* Mon Oct 18 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20211018git
- git snapshot, new repository

* Sat Mar 06 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210306git
- git snapshot

* Wed Jan 20 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210120git
- git snapshot

* Wed Jan 06 2021 Bruno Postle <bruno@postle.net> - 0.0-0.20210106git
- git snapshot
